state Transference in W3MagicVigil
{
	var damage_action			 						: W3DamageAction;
	var damage_value									: float;
	var actors 											: array<CActor>;
	var i												: int;
	var main_effect, effect_entity, quileg_stream		: CEntity;
	var target											: CActor; 
	var entities 										: array<CGameplayEntity>; 
	var position 										: Vector;
	var rotation 										: EulerAngles;
	var targetRotation                                  : EulerAngles;
	var slotMatrix 										: Matrix;
	var ents_destroy									: array< CEntity >;
	var duration										: float;
	var distance										: float;
	var CustomEffect									: SCustomEffectParams;
	var castDir											: Vector;
	var targetPosition									: Vector;
	var teleportPosition								: Vector;
	
	event OnEnterState( prevStateName : name )
	{
		
		/*
		if ( parent.spell_name == 'assassin_tornado' )
		{
			if ( parent.actor && parent.actor.IsAlive() )
			{
				thePlayer.SetSlideTarget( parent.actor );
				parent.AddTimer('rotate_towards_target', 0.0001, true );
			}
		}
		else
		if ( parent.act_signtype == ST_Axii )
		{
			if ( parent.actor && parent.actor.IsAlive() )
			{
				thePlayer.SetSlideTarget( parent.actor );
			}
			else
			{
				thePlayer.AddCustomOrientationTarget( OT_CameraOffset, 'MagicSpells' );
			}
		}
		else*/
		if ( !theGame.GetInGameConfigWrapper().GetVarValue('magic_spells_main', 'cast_to_camera') )
		{
			if ( !GetMagicVigil().IsAlt() )
			{
				if ( parent.actor && parent.actor.IsAlive() )
				{
					thePlayer.SetSlideTarget( parent.actor );
				}
				else
				{
					thePlayer.AddCustomOrientationTarget( OT_CameraOffset, 'MagicSpells' );
				}
			}
		}
		else
		{
			thePlayer.AddCustomOrientationTarget( OT_CameraOffset, 'MagicSpells' );
		}
		
		if ( parent.alternate )
		{
			thePlayer.PushState( 'camera_hack' );     
		}
		
		GetMagicEffectLeft().PlayEffect('transference_hand');
		GetMagicEffectLeft().StopEffect('transference_hand');
	}
	
	event OnCastSpellAnimation( animEventName : name, animEventType : EAnimationEventType, animInfo : SAnimationEventAnimInfo )
	{
		if ( animEventName == 'cast_begin' )
		{
		}
		if ( animEventName == 'cast_throw' )
		{
		}
		if ( animEventName == 'cast_end' )
		{
			cast_spells_transference();
			parent.GotoState( 'Vigil_Dreaming' );
		}
	}
	
	
	private function cast_spells_transference()
	{
		var t  					: float;
		var portal				: CEntity;
	
		if ( parent.spell_name == 'transference_spell' )
		{
		
			if ( parent.actor && parent.actor.IsAlive() && IsRequiredAttitudeBetween(thePlayer, parent.actor, true, false, false) )
			{
				targetPosition = parent.actor.GetWorldPosition();
				targetRotation = parent.actor.GetWorldRotation();
				targetRotation.Yaw = RandRangeF( 180.0, -180.0 );
				castDir = thePlayer.GetHeadingVector();
				
				
				if ( VecDistance(thePlayer.GetWorldPosition(), parent.actor.GetWorldPosition()) <= 5 )
				{
					portal = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'spells_portal' ), targetPosition );
					portal.PlayEffect('teleport');
					portal.StopAllEffects();
					portal.DestroyAfter( 0.5 );
					
					distance = 13;
					
					for ( t = distance; t > 1; t -= 0.2 )
					{
						teleportPosition = TraceFloor( thePlayer.GetWorldPosition() + castDir * t );
						
						if ( theGame.GetWorld().NavigationFindSafeSpot( teleportPosition, 1, 1, position ) )
						{
							if ( TestLineOfSight_spells( position ) )
							{
								parent.actor.TeleportWithRotation( position, targetRotation);
								portal = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'spells_portal' ), position );
								portal.PlayEffect('teleport');
								portal.StopAllEffects();
								portal.DestroyAfter( 1 );
								break;
							}
						}
					}
				}
				else
				{
					distance = 5;
					
					portal = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'spells_portal' ), targetPosition );
					portal.PlayEffect('teleport');
					portal.StopAllEffects();
					portal.DestroyAfter( 1 );
					
					for ( t = 2; t <= distance; t += 0.2 )
					{
						teleportPosition = TraceFloor( thePlayer.GetWorldPosition() + castDir * t );
						
						if ( theGame.GetWorld().NavigationFindSafeSpot( teleportPosition, 1, 1, position ) )
						{
							if ( TestLineOfSight_spells( position ) )
							{
								parent.actor.TeleportWithRotation( position, targetRotation);
								portal = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'spells_portal' ), position );
								portal.PlayEffect('teleport');
								portal.StopAllEffects();
								portal.DestroyAfter( 0.5 );
								break;
							}
						}
					}
				}
				
				damage_action = new W3DamageAction in this;
				damage_action.Initialize(thePlayer,parent.actor,this,thePlayer.GetName()+"_sign",EHRT_None,CPS_Undefined,false, false, true, false );
				damage_action.SetProcessBuffsIfNoDamage(true);
				damage_action.AddEffectInfo( EET_Stagger ); 
				
				theGame.damageMgr.ProcessAction( damage_action );
				delete damage_action;
				
				Spells_drain_stamina( parent.stamina_cost, parent.stamina_delay, parent.signskill );
			}
		}
	}
	
	function TestLineOfSight_spells( pos : Vector ) : bool
	{
		var traceStartPos, traceEndPos, traceEffect, normal : Vector;
		
		traceStartPos = thePlayer.GetWorldPosition();
		traceEndPos = pos;
		
		traceStartPos.Z += 1.8;
		traceEndPos.Z += 1.8;
		
		if( theGame.GetWorld().StaticTrace( traceStartPos, traceEndPos, traceEffect, normal ) )
		{
			if( traceEndPos == traceEffect )
			{
				return true;
			}
			return false;
		}
		else
		{
			return true;
		}
	}
	
	event OnLeaveState( nextStateName : name )
	{
	}
}