function check_ma_spells()
{
	var i 					: int;
	var item_names 			: array<name>;
	var item_names2 		: array<name>;
	var spell_names 		: array<name>;

	spell_names.Clear();
	
	item_names = GetMagicVigil().get_quickslot_item_names();
	for( i=0; i<item_names.Size(); i+=1 )
	{
		if( GetWitcherPlayer().IsItemEquippedByName( item_names[i] ) )
		{		
			if ( item_names[i] == 'fireyrden_tome' )
			{
				spell_names.PushBack('gnosis_fireball_aim');
				spell_names.PushBack('gnosis_trap_aim');
			}
			else
			if ( item_names[i] == 'poisonyrden_tome' )
			{
				spell_names.PushBack('swamp_fireball_aim');
				spell_names.PushBack('swamp_trap_aim');
			}
			else
			if ( item_names[i] == 'permafrost_tome' )
			{
				spell_names.PushBack('frost_ball_aim');
				spell_names.PushBack('frost_trap_aim');
			}
			else
			if ( item_names[i] == 'black_tome' )
			{
				spell_names.PushBack('black_ball_aim');
				spell_names.PushBack('black_trap_aim');
			}
			else
			if ( item_names[i] == 'elaxii_tome' )
			{
				spell_names.PushBack('energy_mine_aim');
			}
			else
			if ( item_names[i] == 'fgolem_tome' )
			{
				spell_names.PushBack('fire_granade_aim');
			}
			else
			if ( item_names[i] == 'igolem_tome' )
			{
				spell_names.PushBack('ice_spear_aim');
			}
			else
			if ( item_names[i] == 'necro_tome' )
			{
				spell_names.PushBack('stone_proj_aim');
			}
		}
	}
	
	item_names2 = GetMagicVigil().get_trophy_item_names();
	for( i=0; i<item_names2.Size(); i+=1 )
	{
		if( GetWitcherPlayer().GetHorseManager().IsItemEquippedByName( item_names2[i] ) )
		{		
			if ( item_names2[i] == 'gwin_tome' )
			{
				spell_names.PushBack('gwin_ball_aim');
				spell_names.PushBack('gwin_heavy_aim');
			}
			else
			if ( item_names2[i] == 'neverwinter_tome' )
			{
				spell_names.PushBack('winter_mine_aim');
				spell_names.PushBack('winter_heavy_aim');
			}
			else
			if ( item_names2[i] == 'fire2_tome' )
			{
				spell_names.PushBack('quileg_mine_aim');
				spell_names.PushBack('quileg_heavy_aim');
			}
			else
			if ( item_names2[i] == 'assassin_tome' )
			{
				spell_names.PushBack('assassin_bolt_aim');
				spell_names.PushBack('assassin_whirl_aim');
			}
			else
			if ( item_names2[i] == 'vampire_tome' )
			{
				spell_names.PushBack('vampire_fence_aim');
			}
		}
	}
	
	
	for( i=0; i<spell_names.Size(); i+=1 )
	{
		GetMagicVigil().add_ma_spell( spell_names[i] );
	}
}

function create_ma_hand_effects()
{	
	var effect, effect2		: CEntity;
	var bonePosition		: Vector;
	var boneRotation		: EulerAngles;
	var eff_name			: name;
	var path, text 			: string;
	
	text = "none";
	
	if ( !GetMagicAim() )
	{
		thePlayer.GetBoneWorldPositionAndRotationByIndex( thePlayer.GetBoneIndex( 'l_forearm' ), bonePosition, boneRotation );
		
		path = "dlc\magicspellsrev\data\entities\manual_aiming\hand_effects_aiming.w2ent";
		effect = theGame.CreateEntity( (CEntityTemplate) LoadResource( path, true ), thePlayer.GetWorldPosition() );
		effect.CreateAttachmentAtBoneWS( thePlayer, 'l_forearm', bonePosition, boneRotation );
		effect.AddTag('magic_spell_aim_effect');
	}
	if ( !GetMagicShoot() )
	{
		path = "dlc\magicspellsrev\data\entities\manual_aiming\hand_effects_shooting.w2ent";
		effect2 = theGame.CreateEntity( (CEntityTemplate) LoadResource( path, true ), thePlayer.GetWorldPosition() );
		effect2.CreateAttachment( thePlayer, 'l_weapon', Vector( 0.5, 0, 0 ));
		effect2.AddTag('magic_spell_shoot_effect');
	}
	
	GetMagicAim().StopAllEffects();
	
	switch( GetMagicVigil().manual_aim_spell )
	{
		case 'stone_proj_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_stone_proj';
					if ( !theSound.SoundIsBankLoaded("monster_golem_dao.bnk") )
					{
						theSound.SoundLoadBank( "monster_golem_dao.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_stone_projectile" );
				}
			break;
		case 'fire_granade_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_igni");
					eff_name = 'ma_fire_bomb';
					if ( !theSound.SoundIsBankLoaded("monster_dracolizard.bnk") )
					{
						theSound.SoundLoadBank( "monster_dracolizard.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_fireentity_projectile" );
				}
			break;
		case 'ice_spear_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_ice_spear';
					if ( !theSound.SoundIsBankLoaded("monster_golem_dao.bnk") )
					{
						theSound.SoundLoadBank( "monster_golem_dao.bnk", false );
					}
					if ( !theSound.SoundIsBankLoaded("ep2_mutations_09.bnk") )
					{
						theSound.SoundLoadBank( "ep2_mutations_09.bnk", false );
					}
					if ( !theSound.SoundIsBankLoaded("monster_golem_ice.bnk") )
					{
						theSound.SoundLoadBank( "monster_golem_ice.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_iceentity_projectile" );
				}
			break;
		case 'gnosis_fireball_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_igni");
					eff_name = 'ma_gnosis_fireball';
					
					text = GetLocStringByKeyExt( "spells_fire_gnosis_fireball" );
				}
			break;
		case 'gnosis_trap_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_gnosis_trap';
					
					text = GetLocStringByKeyExt( "spells_fire_gnosis_trap" );
				}
			break;
		case 'swamp_fireball_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_igni");
					eff_name = 'ma_swamp_fireball';
					if ( !theSound.SoundIsBankLoaded("monster_scolopendromorph.bnk") )
					{
						theSound.SoundLoadBank( "monster_scolopendromorph.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_great_swamp_venom" );
				}
			break;
		case 'swamp_trap_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_swamp_trap';
					
					text = GetLocStringByKeyExt( "spells_great_swamp_trap" );
				}
			break;
		case 'frost_ball_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_frost_ball';
					if ( !theSound.SoundIsBankLoaded("magic_caranthil.bnk") )
					{
						theSound.SoundLoadBank( "magic_caranthil.bnk", false );
					}
					if ( !theSound.SoundIsBankLoaded("ep2_mutations_06.bnk") )
					{
						theSound.SoundLoadBank( "ep2_mutations_06.bnk", false );
					}
					if ( !theSound.SoundIsBankLoaded("magic_sorceress.bnk") )
					{
						theSound.SoundLoadBank( "magic_sorceress.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_permafrost_spear" );
				}
			break;
		case 'frost_trap_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_frost_trap';
					
					text = GetLocStringByKeyExt( "spells_permafrost_trap" );
				}
			break;
		case 'black_ball_aim':
				{	
					thePlayer.SoundEvent("fx_rune_activate_igni");
					eff_name = 'ma_black_ball';
					if ( !theSound.SoundIsBankLoaded("magic_sorceress.bnk") )
					{
						theSound.SoundLoadBank( "magic_sorceress.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_black_fire_projectile" );
				}
			break;
		case 'black_trap_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_black_trap';
					
					text = GetLocStringByKeyExt( "spells_black_fire_trap" );
				}
			break;
		case 'energy_mine_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_energy_mine';
					
					text = GetLocStringByKeyExt( "spells_energy_mine" );
				}
			break;
		case 'gwin_ball_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_gwin_ball';
					if ( !theSound.SoundIsBankLoaded("magic_sorceress.bnk") )
					{
						theSound.SoundLoadBank( "magic_sorceress.bnk", false );
					}
					
					text = GetLocStringByKeyExt( "spells_sunspear" );
				}
			break;
		case 'gwin_heavy_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_gwin_heavy';
					
					text = GetLocStringByKeyExt( "spells_gwin_heavy" );
				}
			break;
		case 'winter_mine_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_winter_mine';
					
					text = GetLocStringByKeyExt( "spells_winter_mine" );
				}
			break;
		case 'winter_heavy_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_winter_heavy';
					
					text = GetLocStringByKeyExt( "spells_winter_heavy" );
				}
			break;
		case 'quileg_mine_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_quileg_mine';
					
					text = GetLocStringByKeyExt( "spells_quileg_mine" );
				}
			break;
		case 'quileg_heavy_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_igni");
					eff_name = 'ma_quileg_heavy';
					
					text = GetLocStringByKeyExt( "spells_quileg_heavy" );
				}
			break;
		case 'assassin_bolt_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_assassin_bolt';
					
					text = GetLocStringByKeyExt( "spells_assassin_bolt" );
				}
			break;
		case 'assassin_whirl_aim':
				{
					thePlayer.SoundEvent("fx_rune_activate_aard");
					eff_name = 'ma_assassin_whirl';
					if ( !theSound.SoundIsBankLoaded("magic_man_mage.bnk") )
					{	
						theSound.SoundLoadBank( "magic_man_mage.bnk", false );	
					}
					
					text = GetLocStringByKeyExt( "spells_assassin_whirl" );
				}
			break;
		case 'vampire_fence_aim':
				{
					thePlayer.SoundEvent("sign_axii_ready");
					eff_name = 'ma_valerie_';
					if ( !theSound.SoundIsBankLoaded("magic_yennefer.bnk") )
					{	
						theSound.SoundLoadBank( "magic_yennefer.bnk", false );	
					}
					
					text = GetLocStringByKeyExt( "spells_vampire_fence" );
				}
			break;
		
		default:		
			break;
	}
	
	GetMagicAim().PlayEffect( eff_name );
	
	if ( text != "none" )
	{
		theGame.GetGuiManager().ShowNotification( text, 1500 );
	}
}

function shoot_ma_hand_spells()
{	
	var eff_name : name;
	var fireball 													: W3FireGnosisFireball;
	var venom														: W3GreatSwampVenom;
	var icespear													: W3PermafrostSpear;
	var sunspear 													: W3SunSpear;
	var blackball 													: W3BlackFireball;
	var pos 														: Vector;
	var castDir														: Vector;
	var slotMatrix													: Matrix;
	var effect, effect2,dummy,fxEntity								: CEntity; 
				
	var boneRotation												: EulerAngles;
	var bonePosition												: Vector;
			
	var results 													: array<SRaycastHitResult>;
	var i, ind 														: int;
	var min 														: float;
	var entity 														: CEntity;
	var targetActor 												: CActor;
	var physTest 													: bool;
	
	var spadtomes  													: SAbilityAttributeValue;
	var eldmg 														: W3DamageAction;
	var elecdmg														: float;
	var npcTarget, npcTarget2 										: CNewNPC;
	var elactors													: array<CActor>;
	
	var fire_trap   												: W3FireGnosisTrap;
	var outPosition, outNormal, tempPosition1, tempPosition2 		: Vector;
	
	var firemine 													: W3MFireMine;
	var electromine 												: W3MElectroMine;
	var frostmine 													: W3MFrostMine;
	var sandprojdummy 												: W3SandProjD;
	var sandproj 													: W3SandProj;
	var fireproj 													: W3FireProj;
	var fireprojdummy 												: W3FireProjD;
	var elproj														: W3ElectroProj;
	var frostproj                                                   : W3MFrostProj;
	var sandbolt													: W3BoltSpells;
	var vampshed													: W3VampShed;
	var vampshed2													: W3VampShed2;
	var vampshed3													: W3VampShed3;
	var vampshed4													: W3VampShed4;
	var path 														: string;
	var ents_destroy												: array< CEntity >;
	var rotation													: EulerAngles;
	var swamp_trap   												: W3GreatSwampTrap;
	var permafrost_trap   											: W3PermafrostTrap;
	var black_trap   												: W3BlackFireTrap;
	
	var stamina_cost, stamina_delay, duration						: float;
	var IceentityBolt 												: W3IceentityBolt;
	var IgniGranade 												: W3MIgniGranade;
	var Stone			 											: W3SpellsStoneProj;

	eff_name = 'nothing';
	
	stamina_cost = Spells_overall_stamina_cost();
	stamina_cost -= 10;

	switch( GetMagicVigil().manual_aim_spell )
	{
		case 'stone_proj_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\rockwatcher_stone_proj.w2ent";
						Stone = (W3SpellsStoneProj)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						Stone.AddTag( 'spells_custom_projs' );
						Stone.Init(NULL);
						Stone.PlayEffect( 'glow' );
						Stone.ShootProjectileAtPosition(0, 17, thePlayer.playerAiming.GetThrowPosition() );
						Stone.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_assassin_shoot' );
						GetMagicShoot().PlayEffect( 'hit_assassin_shoot2' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'fire_granade_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\fireentity_projectile.w2ent";
						IgniGranade = (W3MIgniGranade)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						IgniGranade.AddTag( 'spells_custom_projs' );
						IgniGranade.Init(NULL);
						IgniGranade.PlayEffect( 'fire_fx2' );
						IgniGranade.PlayEffect( 'fire_fx3' );
						IgniGranade.ShootProjectileAtPosition(0, 20, thePlayer.playerAiming.GetThrowPosition() );
						IgniGranade.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_fire' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'ice_spear_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\iceentity_bolt.w2ent";
						IceentityBolt = (W3IceentityBolt)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						IceentityBolt.AddTag( 'spells_custom_projs' );
						IceentityBolt.Init(NULL);
						IceentityBolt.ShootProjectileAtPosition(0, 25, thePlayer.playerAiming.GetThrowPosition() );
						IceentityBolt.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_ice' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'gnosis_fireball_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\fire_gnosis_fireball.w2ent";
						fireball = (W3FireGnosisFireball)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						fireball.AddTag( 'spells_custom_projs' );
						fireball.Init(NULL);
						fireball.PlayEffect( 'fire_fx' );
						fireball.ShootProjectileAtPosition(0, 20, thePlayer.playerAiming.GetThrowPosition() );
						fireball.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_fire' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'gnosis_trap_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						theGame.GetEntitiesByTag('fire_gnosis_trap_spells',ents_destroy);
						for( i=0; i<ents_destroy.Size(); i+=1 )
						{
							ents_destroy[i].AddTimer('destroy_fire_trap',0.0f);
						} 	
							
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
							
						rotation = thePlayer.GetWorldRotation();
						
						duration = 10;
						duration += duration * ( get_spellpower_spells( true ) * 0.5 );
						
						theGame.GetSurfacePostFX().AddSurfacePostFXGroup( TraceFloor( pos ), 1.f, duration, 1.f, 4.f, 1);
							
						path = "dlc\magicspellsrev\data\entities\fire_gnosis_trap.w2ent";
							
						fire_trap = (W3FireGnosisTrap)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos, rotation );
						fire_trap.AddTimer('destroy_fire_trap', duration );
						fire_trap.AddTag('fire_gnosis_trap_spells');
					
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('quileg_mine_line', dummy );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'swamp_fireball_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\great_swamp_venom_projectile.w2ent";
						venom = (W3GreatSwampVenom)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						venom.AddTag( 'spells_custom_projs' );
						venom.Init(NULL);
						venom.PlayEffect( 'venom' );
						venom.ShootProjectileAtPosition(0, 15, thePlayer.playerAiming.GetThrowPosition() );
						venom.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_swamp' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'swamp_trap_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						theGame.GetEntitiesByTag('great_swamp_trap_spells',ents_destroy);
						for( i=0; i<ents_destroy.Size(); i+=1 )
						{
							ents_destroy[i].AddTimer('destroy_swamp_trap',0.0f);
						} 	
							
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
							
						rotation = thePlayer.GetWorldRotation();
						
						duration = 10;
						duration += duration * ( get_spellpower_spells( true ) * 0.5 );
						//theGame.witcherLog.AddMessage("DURATION  = " + (string)duration );
						
						path = "dlc\magicspellsrev\data\entities\great_swamp_trap.w2ent";
							
						swamp_trap = (W3GreatSwampTrap)theGame.CreateEntity( (CEntityTemplate)LoadResource( path,true ), pos, rotation );
						swamp_trap.AddTimer('destroy_swamp_trap', duration );
						swamp_trap.AddTag('great_swamp_trap_spells');
					
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('swamp_line', dummy );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'frost_ball_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\permafrost_icespear.w2ent";
						icespear = (W3PermafrostSpear)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						icespear.AddTag( 'spells_custom_projs' );
						icespear.Init(NULL);
						icespear.PlayEffect( 'fire_fx' );
						icespear.PlayEffect( 'fire_fx2' );
						icespear.ShootProjectileAtPosition(0, 15, thePlayer.playerAiming.GetThrowPosition() );
						icespear.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_ice' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'frost_trap_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						theGame.GetEntitiesByTag('permafrost_trap_spells',ents_destroy);
						for( i=0; i<ents_destroy.Size(); i+=1 )
						{
							ents_destroy[i].AddTimer('destroy_permafrost_trap',0.0f);
						} 	
							
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
							
						rotation = thePlayer.GetWorldRotation();
						
						duration = 10;
						duration += duration * ( get_spellpower_spells( true ) * 0.5 );
						
						theGame.GetSurfacePostFX().AddSurfacePostFXGroup( TraceFloor( pos ), 1.f, duration, 1.f, 10.f, 0);
							
						path = "dlc\magicspellsrev\data\entities\permafrost_trap.w2ent";
							
						permafrost_trap = (W3PermafrostTrap)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos, rotation );
						permafrost_trap.AddTimer('destroy_permafrost_trap', duration );
						permafrost_trap.AddTag('permafrost_trap_spells');
					
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('winter_mine_line', dummy );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'black_ball_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;

						path = "dlc\magicspellsrev\data\entities\black_fire_projectile.w2ent";
						blackball = (W3BlackFireball)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						blackball.AddTag( 'spells_custom_projs' );
						blackball.Init(NULL);
						blackball.PlayEffect( 'venom' );
						blackball.ShootProjectileAtPosition(0, 15, thePlayer.playerAiming.GetThrowPosition() );
						blackball.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_black' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'black_trap_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						theGame.GetEntitiesByTag('black_fire_trap_spells',ents_destroy);
						for( i=0; i<ents_destroy.Size(); i+=1 )
						{
							ents_destroy[i].AddTimer('destroy_black_trap',0.0f);
						} 	
							
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
							
						rotation = thePlayer.GetWorldRotation();
						
						duration = 10;
						duration += duration * ( get_spellpower_spells( true ) * 0.5 );
						
						path = "dlc\magicspellsrev\data\entities\black_fire_trap.w2ent";
							
						black_trap = (W3BlackFireTrap)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos, rotation );
						black_trap.AddTimer('destroy_black_trap', duration );
						black_trap.AddTag('black_fire_trap_spells');
					
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('black_line', dummy );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'energy_mine_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
					
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						//tempPosition2.Z += 100;

						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
						
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('electro_mine_line', dummy );
							
						path = "dlc\magicspellsrev\data\entities\manual_aiming\mines\electro_mine.w2ent";	
						electromine = (W3MElectroMine)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						electromine.StopAllEffectsAfter(30);
						electromine.DestroyAfter(32);
							
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'gwin_ball_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;
					
						path = "dlc\magicspellsrev\data\entities\old_gods_sunspear.w2ent";
						sunspear = (W3SunSpear)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						sunspear.AddTag( 'spells_custom_projs' );
						sunspear.Init(NULL);
						sunspear.PlayEffect( 'fire_fx' );
						sunspear.PlayEffect( 'fire_fx2' );
						sunspear.ShootProjectileAtPosition(0, 15, thePlayer.playerAiming.GetThrowPosition() );
						sunspear.DestroyAfter(10);

						GetMagicShoot().PlayEffect( 'hit_gwin' );
						GetMagicShoot().PlayEffect( 'hit_gwin2' );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'gwin_heavy_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\electro_projectile.w2ent";
						elproj = (W3ElectroProj)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						elproj.AddTag('spells_custom_projs');
						elproj.Init(NULL);
						elproj.ShootProjectileAtPosition(0, 20, thePlayer.playerAiming.GetThrowPosition() );
						elproj.AddTimer('spells_destroy_electro_proj', 2 );
			
						GetMagicShoot().PlayEffect( 'hit_gwin_wave' );
						GetMagicShoot().PlayEffect( 'hit_gwin_wave2' );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'winter_mine_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
					
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						//tempPosition2.Z += 100;

						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
						
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('winter_mine_line', dummy );
							
						path = "dlc\magicspellsrev\data\entities\manual_aiming\mines\frost_mine.w2ent";	
						frostmine = (W3MFrostMine)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						frostmine.StopAllEffectsAfter(30);
						frostmine.DestroyAfter(32);
							
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'winter_heavy_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						castDir = MatrixGetAxisX( slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\frost_projectile.w2ent";
						frostproj = (W3MFrostProj)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						frostproj.AddTag('spells_custom_projs');
						frostproj.PreloadEffect('venom');fireproj.PreloadEffect('venom1');
						frostproj.Init(NULL);
						frostproj.ShootProjectileAtPosition(0, 20, thePlayer.playerAiming.GetThrowPosition() );
						frostproj.AddTimer('spells_destroy_frost_proj', 1.5 );
						frostproj.AddTag('frostproj');
			
						GetMagicShoot().PlayEffect( 'hit_frost2' );
						GetMagicShoot().PlayEffect( 'hit_frost' );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'quileg_mine_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
					
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent("fx_fire_geralt_fire_hit");
					
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						//tempPosition2.Z += 100;

						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
						
						dummy = theGame.CreateEntity( (CEntityTemplate)LoadResource( 'manaim_effects' ), pos  );
						dummy.DestroyAfter(1);
						
						GetMagicShoot().PlayEffect('quileg_mine_line', dummy );
							
						path = "dlc\magicspellsrev\data\entities\manual_aiming\mines\fire_mine.w2ent";	
						firemine = (W3MFireMine)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
						firemine.StopAllEffectsAfter(30);
						firemine.DestroyAfter(32);
							
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'quileg_heavy_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						castDir = MatrixGetAxisX( slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + theCamera.GetCameraDirection() * 0.4;
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\quileg_projectile.w2ent";
						fireproj = (W3FireProj)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						fireproj.AddTag('spells_custom_projs');
						fireproj.PreloadEffect('venom');fireproj.PreloadEffect('venom1');
						fireproj.Init(NULL);
						fireproj.ShootProjectileAtPosition(0, 50, thePlayer.playerAiming.GetThrowPosition() );
						fireproj.AddTimer('spells_destroy_fire_proj', 1 );
						fireproj.AddTag('fireproj');
						
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\quileg_projectile_dummy.w2ent";
						fireprojdummy = (W3FireProjD)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						fireprojdummy.AddTag('spells_custom_projs');
						fireprojdummy.Init(NULL);
						fireprojdummy.ShootProjectileAtPosition(0, 1, thePlayer.playerAiming.GetThrowPosition() );
						fireprojdummy.DestroyAfter(3);
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
						
						GetMagicShoot().PlayEffect( 'hit_quileg1' );
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'assassin_bolt_aim':
				{
					stamina_cost = stamina_cost / 2;
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.3;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.SoundEvent( "cmb_arrow_swoosh" );thePlayer.SoundEvent( "cmb_arrow_swoosh" );
					
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix );// + theCamera.GetCameraDirection()*0.4;
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\assassin_bolt.w2ent";
						sandbolt = (W3BoltSpells)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						sandbolt.AddTag('spells_custom_projs');
						sandbolt.Init(NULL);
						sandbolt.ShootProjectileAtPosition(0, 60, thePlayer.playerAiming.GetThrowPosition() );
						
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
						
						
						GetMagicShoot().PlayEffect( 'hit_assassin_shoot' );
						GetMagicShoot().PlayEffect( 'hit_assassin_shoot2' );
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'assassin_whirl_aim':
				{
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.5;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
						thePlayer.CalcEntitySlotMatrix( 'l_weapon', slotMatrix );
						castDir = MatrixGetAxisX( slotMatrix );
						pos =  MatrixGetTranslation( slotMatrix ) + castDir * 0.4;
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\assassin_sand_projectile_dummy.w2ent";
						sandprojdummy = (W3SandProjD)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						sandprojdummy.AddTag('spells_custom_projs');
						sandprojdummy.Init(NULL);
						sandprojdummy.ShootProjectileAtPosition(0, 5, thePlayer.playerAiming.GetThrowPosition() );
						sandprojdummy.DestroyAfter(3);
						sandprojdummy.AddTag('sandprojdummy');
					
						path = "dlc\magicspellsrev\data\entities\manual_aiming\projs\assassin_sand_projectile.w2ent";
						sandproj = (W3SandProj)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos  );
						sandproj.AddTag('spells_custom_projs');
						sandproj.Init(NULL);
						sandproj.ShootProjectileAtPosition(0, 20, thePlayer.playerAiming.GetThrowPosition() );
						sandproj.AddTimer('spells_destroy_sand_proj', 1.5 );
					
						GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
						
						GetMagicShoot().PlayEffect( 'hit_assassin' );
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		case 'vampire_fence_aim':
				{
					stamina_cost = stamina_cost / 2;
					stamina_cost += stamina_cost * get_stamina_cost_mult_man_aim(); 
					
					stamina_delay = 0.4;
					stamina_delay += stamina_delay * get_stamina_delay_mult_man_aim(); 
				
					if ( thePlayer.GetStat(BCS_Stamina) > stamina_cost )
					{
					
						tempPosition1 = thePlayer.playerAiming.GetThrowPosition();
						tempPosition1.Z -= 100;
						tempPosition2 = thePlayer.playerAiming.GetThrowPosition();
						if ( theGame.GetWorld().StaticTrace( tempPosition2, tempPosition1, outPosition, outNormal ) )
						{
							pos = outPosition;
						}
						else
						{
							pos = thePlayer.playerAiming.GetThrowPosition();
						}
						pos.Z += 0.7;
						
						
						if ( theGame.GetEntityByTag( 'vamp_shed_pillar_1' ) && theGame.GetEntityByTag( 'vamp_shed_pillar_2' ) 
													&& theGame.GetEntityByTag( 'vamp_shed_pillar_3' ) && !theGame.GetEntityByTag( 'vamp_shed_pillar_4' ) )
						{
							path = "dlc\magicspellsrev\data\entities\manual_aiming\vampyr\vamp_shed4.w2ent";
							vampshed4 = (W3VampShed4)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
							vampshed4.AddTag( 'vamp_shed_pillar_4' );
							vampshed4.AddTag( 'vamp_shed_pillars' );
							vampshed4.AddTag( 'vampire_pillar_fence' );
							
							GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
							eff_name = 'hit_vampyr';
							thePlayer.SoundEvent("magic_yennefer_q310_spell_03");
						}
						
						if ( theGame.GetEntityByTag( 'vamp_shed_pillar_1' ) && theGame.GetEntityByTag( 'vamp_shed_pillar_2' ) && !theGame.GetEntityByTag( 'vamp_shed_pillar_3' ) )
						{
							path = "dlc\magicspellsrev\data\entities\manual_aiming\vampyr\vamp_shed3.w2ent";
							vampshed3 = (W3VampShed3)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
							vampshed3.AddTag( 'vamp_shed_pillar_3' );
							vampshed3.AddTag( 'vamp_shed_pillars' );
							vampshed3.AddTag( 'vampire_pillar_fence' );
							
							GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
							eff_name = 'hit_vampyr';
							thePlayer.SoundEvent("magic_yennefer_q310_spell_03");
						}
						
						if ( theGame.GetEntityByTag( 'vamp_shed_pillar_1' ) && !theGame.GetEntityByTag( 'vamp_shed_pillar_2' ) )
						{
							path = "dlc\magicspellsrev\data\entities\manual_aiming\vampyr\vamp_shed2.w2ent";
							vampshed2 = (W3VampShed2)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
							vampshed2.AddTag( 'vamp_shed_pillar_2' );
							vampshed2.AddTag( 'vamp_shed_pillars' );
							vampshed2.AddTag( 'vampire_pillar_fence' );
							
							GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
							eff_name = 'hit_vampyr';
							thePlayer.SoundEvent("magic_yennefer_q310_spell_03");
						}
				
						if ( !theGame.GetEntityByTag( 'vamp_shed_pillar_1' ) )
						{
							path = "dlc\magicspellsrev\data\entities\manual_aiming\vampyr\vamp_shed.w2ent";
							vampshed = (W3VampShed)theGame.CreateEntity( (CEntityTemplate)LoadResource( path, true ), pos );
							vampshed.AddTimer('destroy_vamp_pillar_fence',29);
							vampshed.AddTag( 'vamp_shed_pillar_1' );
							vampshed.AddTag( 'vamp_shed_pillars' );
							vampshed.AddTag( 'vampire_pillar_fence' );
							
							GetWitcherPlayer().DrainStamina( ESAT_FixedValue, stamina_cost, stamina_delay ); 
							eff_name = 'hit_vampyr';
							thePlayer.SoundEvent("magic_yennefer_q310_spell_03");
						}
						
						GetMagicShoot().PlayEffect( eff_name );
					}
					else
					{
						thePlayer.SoundEvent("gui_no_stamina");
					}
				}
			break;
		
		default:		
			break;
	}
	
	//theGame.witcherLog.AddMessage("STAMINA   =   " + stamina_cost );

}
